#!/bin/sh
#
# check_ide: download list from sophos and compare with current
#
DOWNLOAD_DIR="/usr/local/sophos-av/downloads"
IDE_DIR=".."

LIST=`sweep -v | sed -n '/Product version/{
s|^[^:]*:[ 	]*||
s|\.||
s|[ 	]||g
p
}'`
LIST="${LIST}_list.txt"
cd $DOWNLOAD_DIR
rm -f $LIST
wget -nd -q http://www.sophos.com/downloads/ide/$LIST
if [ $? -ne 0 -o ! -f $LIST ]; then
	echo "wget failed to get $LIST. check_ide aborted." 1>&2
	exit 1
fi

# check for new ides
#
exec < $LIST
count="0"
missing="0"
newide=""
read ide
while [ $? -eq 0 ]; do
	if [ ! "x$ide" = "x" ]; then
		file=`echo $ide | sed -n 's|[^/]*/||gp'`
		if [ ! -f $IDE_DIR/$file ]; then
			wget -nd -q -O $file $ide
			if [ $? -ne 0 -o ! -f $file ]; then
				echo "wget failed to get $file." 1>&2
			else
				newide="$newide $file"
			fi
			missing=`expr $missing + 1`
		fi
		count=`expr $count + 1`
	fi
	read ide
done
curr=`ls -1 $IDE_DIR/*.ide | wc -l`
total=`expr $curr + $missing`
if [ $count -ne $total ]; then
	echo "Wrong ide count: $curr installed in $IDE_DIR, $missing missing, $count in list" 2>&1
fi
if [ $missing -gt 0 ]; then
	echo "$missing missing ide(s). retrieved: $newide"
	mv $newide $IDE_DIR
	cd $IDE_DIR
	chmod a+r $newide
else
	echo "$count ide(s) in list are installed already."
fi
