/*
** compatibility version of vsnprintf and fputs
*/
/*
** Part of MIMEC: see NOTICE.txt
** Copyright (c) 1999 Alessandro Vesely
** All rights reserved.
*/
#include <stdio.h>
#include <string.h>

int vsnprintf(char* d, int m, char const* fmt, void* args)
{
	FILE *fp = tmpfile();
	int rtc = -1;

	if (fp)
	{
		int n = vfprintf(fp, fmt, args);
		int av = n < m ? n : m - 1; 
		if (fseek(fp, 0, SEEK_SET) == 0 &&
			fread(d, 1, av, fp) == av)
		{
			d[av] = 0;
			rtc = n;
		}
		fclose(fp);
	}
	return rtc;		
}

int myfputs(char const *s, FILE*fp)
{
	size_t n = strlen(s);
	return fwrite(s, 1, n, fp);
}
